<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<title>Five Stars - Update v8</title>
	<link rel="stylesheet" href="styles/base.css" type="text/css">
	<link rel="stylesheet" href="styles/advanced.css" type="text/css">
</head>
<body>

<?php
$productID = $_GET['productID'];

/* check that the productID variable is valid */
$dbfile = new PDO('sqlite:products.db3');
$checkProducts = "SELECT DISTINCT ProductReference FROM products;";
$query = $dbfile->query($checkProducts);
$validProducts = $query->fetchAll();

/* basic linear search to validate the product ID */
$validation = 0;
foreach ($validProducts as $element)
{
	if ($element[0] == $productID)
	{
		$validation = 1;
	}
}

if ($validation == 0)
{
	print ("<p>Sorry, the product ID is invalid.</p>\n");
	print ("<p><a href=\"index.php\">Index</a></p>\n");
	print ("</body>\n</html>\n");
	exit;
}
else
{
	/* get the name of the product */
	$checkProducts = "SELECT ProductName FROM products WHERE ProductReference=$productID;";
	$query = $dbfile->query($checkProducts);
	$result = $query->fetchAll();
	$productName = $result[0][ProductName];
}

/* checking if a cookie as already been set */
if (isset($_COOKIE[$productID]))
{
	if ($_COOKIE[$productID] == "yes")
	{
		print ("<p>Sorry, you already have evaluated this product.</p>\n");
		print ("<p><a href=\"index.php\">Index</a></p>\n");
		print ("</body>\n</html>\n");
		exit;
	}
}

if (isset($_POST['rating']))
{
	switch($_POST['rating'])
	{
		case 'one':
			$message = "<p>You have rated this product to one star.</p>\n";
			$update = "UPDATE products SET OneStar = OneStar + 1 WHERE ProductReference = $productID;";
			break;
		case 'two':
			$message = "<p>You have rated this product to two stars.</p>\n";
			$update = "UPDATE products SET TwoStars = TwoStars + 1 WHERE ProductReference = $productID;";
			break;
		case 'three':
			$message = "<p>You have rated this product to three stars.</p>\n";
			$update = "UPDATE products SET ThreeStars = ThreeStars + 1 WHERE ProductReference = $productID;";
			break;
		case 'four':
			$message = "<p>You have rated this product to four stars.</p>\n";
			$update = "UPDATE products SET FourStars = FourStars + 1 WHERE ProductReference = $productID;";
			break;
		case 'five':
			$message = "<p>You have rated this product to five stars.</p>\n";
			$update = "UPDATE products SET FiveStars = FiveStars + 1 WHERE ProductReference = $productID;";
			break;
		default:
			$message = "<p>Invalid rating.</p>\n";
	}

}
?>
	<h1>Five Stars - Update v8</h1>

<?php
print("<p>Product: $productName ($productID)</p>");

if (isset($message))
{
	print ($message);

	if (isset($update))
	{
		/* increment the star rating in the database */
		$dbfile->exec($update);
		$dbfile = null;

		/* write a cookie to record the action (5 minutes) */
		/* (name, value, expires, path, domain, secure, httponly) */
		setcookie("$productID", "yes", time()+300, null, null, true, true);
	}
}
else
{
	print ("<form method=\"post\" action=\"update-v8.php?productID=$productID\">\n<fieldset>\n");

	$choices = array("five", "four", "three", "two", "one");

	/* print each option row from five stars to one */
	for ($i = 0; $i < 5 ; $i++)
	{
		print ("<label><input type=\"radio\" name=\"rating\" value=\"$choices[$i]\">\n<span>\n");

		/* print as many "full stars" as needed */
		for ($j = (5 - $i); $j > 0; $j--)
		{
			print ("<img src=\"stars/Full_Star_Yellow.svg\" height=\"32\" width=\"32\" alt=\"Full Star\">\n");
		}

		/* print as many "empty stars" as needed */
		for ($j = $i; $j > 0; $j--)
		{
			print ("<img src=\"stars/Empty_Star.svg\" height=\"32\" width=\"32\" alt=\"Empty Star\">\n");
		}

		print ("</span>\n</label>\n");
	}

	print ("<input type=\"submit\" value=\"Rate this product\">\n");
	print ("</fieldset></form>\n");
	print ("<p>Note: using this form will create a cookie in your web browser.</p>\n");
}
?>

<p><a href="index.php">Index</a></p>
</body>
</html>
